using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.Runtime.InteropServices;

namespace TestDriver
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
		[DllImport("winmm.dll")]
		static extern short midiOutGetNumDevs();
		
		[DllImport("winmm.dll")]
		static extern int midiOutGetDevCaps(int uDeviceID, out MIDIOUTCAPS lpCaps, int uSize);

		[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Ansi)]
		struct MIDIOUTCAPS
		{
			public ushort wMid;
			public ushort wPid;
			public uint vDriverVersion;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=32)]
			public string szPname;
			public ushort wTechnology;
			public ushort wVoices;
			public ushort wNotes;
			public ushort wChannelMask;
			public uint dwSupport;
		}

		private nkmidi.Player midiPlayer;
		private bool isPlaying;

		private System.Windows.Forms.TextBox textFilename;
		private System.Windows.Forms.Button buttonLoad;
		private System.Windows.Forms.TextBox textOutput;
		private System.Windows.Forms.Button buttonPlayStop;
		private System.Windows.Forms.Button buttonTest;
		private System.Windows.Forms.Label labelTempo;
		private System.Windows.Forms.TextBox textTempo;
		private System.Windows.Forms.Button buttonDump;
		private System.Windows.Forms.Button buttonChangeTempo;
		private System.Windows.Forms.ListBox listDevices;
		private System.Windows.Forms.Button buttonBrowse;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormMain()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.textFilename = new System.Windows.Forms.TextBox();
			this.buttonLoad = new System.Windows.Forms.Button();
			this.textOutput = new System.Windows.Forms.TextBox();
			this.buttonPlayStop = new System.Windows.Forms.Button();
			this.buttonTest = new System.Windows.Forms.Button();
			this.labelTempo = new System.Windows.Forms.Label();
			this.textTempo = new System.Windows.Forms.TextBox();
			this.buttonDump = new System.Windows.Forms.Button();
			this.buttonChangeTempo = new System.Windows.Forms.Button();
			this.listDevices = new System.Windows.Forms.ListBox();
			this.buttonBrowse = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textFilename
			// 
			this.textFilename.Location = new System.Drawing.Point(16, 16);
			this.textFilename.Name = "textFilename";
			this.textFilename.Size = new System.Drawing.Size(344, 19);
			this.textFilename.TabIndex = 0;
			this.textFilename.Text = "";
			// 
			// buttonLoad
			// 
			this.buttonLoad.Location = new System.Drawing.Point(16, 48);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.Size = new System.Drawing.Size(80, 32);
			this.buttonLoad.TabIndex = 1;
			this.buttonLoad.Text = "Load";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			// 
			// textOutput
			// 
			this.textOutput.Location = new System.Drawing.Point(16, 216);
			this.textOutput.Multiline = true;
			this.textOutput.Name = "textOutput";
			this.textOutput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textOutput.Size = new System.Drawing.Size(432, 192);
			this.textOutput.TabIndex = 2;
			this.textOutput.Text = "";
			// 
			// buttonPlayStop
			// 
			this.buttonPlayStop.Location = new System.Drawing.Point(112, 48);
			this.buttonPlayStop.Name = "buttonPlayStop";
			this.buttonPlayStop.Size = new System.Drawing.Size(72, 32);
			this.buttonPlayStop.TabIndex = 3;
			this.buttonPlayStop.Text = "Play";
			this.buttonPlayStop.Click += new System.EventHandler(this.buttonPlayStop_Click);
			// 
			// buttonTest
			// 
			this.buttonTest.Location = new System.Drawing.Point(376, 48);
			this.buttonTest.Name = "buttonTest";
			this.buttonTest.Size = new System.Drawing.Size(72, 32);
			this.buttonTest.TabIndex = 4;
			this.buttonTest.Text = "Test";
			this.buttonTest.Click += new System.EventHandler(this.buttonTest_Click);
			// 
			// labelTempo
			// 
			this.labelTempo.Location = new System.Drawing.Point(16, 112);
			this.labelTempo.Name = "labelTempo";
			this.labelTempo.Size = new System.Drawing.Size(48, 16);
			this.labelTempo.TabIndex = 5;
			this.labelTempo.Text = "Tempo";
			// 
			// textTempo
			// 
			this.textTempo.Location = new System.Drawing.Point(64, 112);
			this.textTempo.Name = "textTempo";
			this.textTempo.Size = new System.Drawing.Size(48, 19);
			this.textTempo.TabIndex = 6;
			this.textTempo.Text = "";
			// 
			// buttonDump
			// 
			this.buttonDump.Location = new System.Drawing.Point(376, 96);
			this.buttonDump.Name = "buttonDump";
			this.buttonDump.Size = new System.Drawing.Size(72, 32);
			this.buttonDump.TabIndex = 7;
			this.buttonDump.Text = "Dump";
			this.buttonDump.Click += new System.EventHandler(this.buttonDump_Click);
			// 
			// buttonChangeTempo
			// 
			this.buttonChangeTempo.Location = new System.Drawing.Point(128, 104);
			this.buttonChangeTempo.Name = "buttonChangeTempo";
			this.buttonChangeTempo.Size = new System.Drawing.Size(56, 32);
			this.buttonChangeTempo.TabIndex = 8;
			this.buttonChangeTempo.Text = "Change Tempo";
			this.buttonChangeTempo.Click += new System.EventHandler(this.buttonChangeTempo_Click);
			// 
			// listDevices
			// 
			this.listDevices.ItemHeight = 12;
			this.listDevices.Location = new System.Drawing.Point(208, 48);
			this.listDevices.Name = "listDevices";
			this.listDevices.ScrollAlwaysVisible = true;
			this.listDevices.Size = new System.Drawing.Size(152, 76);
			this.listDevices.TabIndex = 9;
			// 
			// buttonBrowse
			// 
			this.buttonBrowse.Location = new System.Drawing.Point(376, 16);
			this.buttonBrowse.Name = "buttonBrowse";
			this.buttonBrowse.Size = new System.Drawing.Size(72, 24);
			this.buttonBrowse.TabIndex = 10;
			this.buttonBrowse.Text = "Browse...";
			this.buttonBrowse.Click += new System.EventHandler(this.buttonBrowse_Click);
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(464, 422);
			this.Controls.Add(this.buttonBrowse);
			this.Controls.Add(this.listDevices);
			this.Controls.Add(this.buttonChangeTempo);
			this.Controls.Add(this.buttonDump);
			this.Controls.Add(this.textTempo);
			this.Controls.Add(this.textOutput);
			this.Controls.Add(this.textFilename);
			this.Controls.Add(this.labelTempo);
			this.Controls.Add(this.buttonTest);
			this.Controls.Add(this.buttonPlayStop);
			this.Controls.Add(this.buttonLoad);
			this.MaximizeBox = false;
			this.Name = "FormMain";
			this.Text = "TestDriver for nkmidi";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.FormMain_Closing);
			this.Load += new System.EventHandler(this.FormMain_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		private void FormMain_Load(object sender, System.EventArgs e)
		{
			midiPlayer = null;
			isPlaying = false;

			this.textFilename.Text = @"C:\Documents and Settings\kenzi\My Documents\midi\files\tokino_c.mid";
			this.buttonPlayStop.Text = "Play";
			this.buttonPlayStop.Enabled = false;
			this.buttonChangeTempo.Enabled = false;

			// foCX\
			int devices = midiOutGetNumDevs();
			MIDIOUTCAPS outCaps = new MIDIOUTCAPS();

			for (int i=0; i<devices; i++)
			{
				midiOutGetDevCaps(i, out outCaps, Marshal.SizeOf(typeof(MIDIOUTCAPS)));
				if ( outCaps.szPname != "")
				{
					this.listDevices.Items.Add( outCaps.szPname );
				}
			}
		}

		private void FormMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.stop();
		}

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			this.buttonPlayStop.Enabled = false;

			midiPlayer = new nkmidi.Player();
			midiPlayer.EndOfSequenceCallback = new nkmidi.NotifyCallback(endOfSequenceCallback);
			midiPlayer.load(this.textFilename.Text);

			this.textTempo.Text = midiPlayer.Sequence.StartingTempo.ToString();

			this.buttonPlayStop.Enabled = true;
			this.buttonChangeTempo.Enabled = true;

//			nkmidi.EventHandler handler1 = new nkmidi.EventHandler();
//			handler1.Callback = new nkmidi.EventCallback(eventCallback);
//			midiPlayer.addHandler(handler1);
			nkmidi.MetaEventHandler set_tempo_handler = new nkmidi.MetaEventHandler(nkmidi.Meta.MetaEvent.EVENTTYPE_SET_TEMPO);
			set_tempo_handler.Callback = new nkmidi.MetaEventCallback(tempoChangeCallback);
			midiPlayer.addHandler(set_tempo_handler);
		}

		private void buttonPlayStop_Click(object sender, System.EventArgs e)
		{
			if ( !isPlaying ) 
			{
				this.play();
			}
			else 
			{
				this.stop();
			}
		}

		private void play()
		{
			if ( midiPlayer == null )
			{
				return;
			}

			midiPlayer.DeviceID = this.listDevices.SelectedIndex;
			midiPlayer.play();

			isPlaying = true;
			this.buttonPlayStop.Text = "Stop";
			this.buttonLoad.Enabled = false;
			this.listDevices.Enabled = false;
		}

		private void stop()
		{
			if (midiPlayer != null)
			{
				midiPlayer.stop();
			}

			isPlaying = false;
			this.buttonPlayStop.Text = "Play";
			this.buttonLoad.Enabled = true;
			this.listDevices.Enabled = true;
		}

		private void buttonTest_Click(object sender, System.EventArgs e)
		{
			bool debug_echo = true;

			nkmidi.SMF smf = new nkmidi.SMF(this.textFilename.Text); 
			smf.read();

			// tests begin here...
			StringBuilder sbOutput = new StringBuilder();

			// header chunk type
			if ( debug_echo ) 
			{
				sbOutput.Append("Test echo: header chunk type = " +  smf.HeaderChunkType + Environment.NewLine);
			}
			if ( smf.HeaderChunkType != "MThd" ) 
			{
				sbOutput.Append("Test failed: header chunk type = " + smf.HeaderChunkType + Environment.NewLine);
			}

			// header data length
			if ( debug_echo ) 
			{
				sbOutput.Append("Test echo: header data length = " +  smf.HeaderDataLength + Environment.NewLine);
			}
			if ( smf.HeaderDataLength != 6 ) 
			{
				sbOutput.Append("Test failed: header data length = " + smf.HeaderDataLength + Environment.NewLine);
			}

			// end of the tests

			this.textOutput.Text = sbOutput.ToString();
		}

		private void buttonDump_Click(object sender, System.EventArgs e)
		{
			StringBuilder sbOutput = new StringBuilder();

			nkmidi.SMF smf = new nkmidi.SMF(this.textFilename.Text); 
			smf.read();

			nkmidi.MIDITrack[] tracks = smf.Tracks;
			for (int i=0; i<tracks.Length; i++) 
			{
				sbOutput.Append("*** Track " + i + " ***" + Environment.NewLine);

				nkmidi.MIDIEvent[] events = tracks[i].getEvents();
				for (int j=0; j<events.Length; j++) 
				{
					nkmidi.MIDIEvent ev = events[j];
					sbOutput.Append("[" + j + "] ");

					int dt = (int)ev.DeltaTime;
					sbOutput.Append("dt=" + dt + ": ");

					if ( ev.IsMetaEvent )
					{
						sbOutput.Append("MetaEvent ");
						sbOutput.Append( Convert.ToString(ev.MetaEvent.EventType, 16) );
					}
					else
					{
						byte[] bytes = ev.RawData;
						sbOutput.Append( Convert.ToString(bytes[0], 16) );
					}

					sbOutput.Append(Environment.NewLine);
				}
			}

			this.textOutput.Text = sbOutput.ToString();
		}

//		public bool eventCallback(nkmidi.MIDIEvent ev)
//		{
//			this.textOutput.Text += Convert.ToString((ev.RawData)[0], 16) + " " + Environment.NewLine;
//
//			return false;
//		}

		public void tempoChangeCallback(nkmidi.Meta.MetaEvent mev)
		{
			this.textTempo.Text = midiPlayer.Tempo.ToString();
		}

		public void endOfSequenceCallback()
		{
			this.stop();
		}

		private void buttonChangeTempo_Click(object sender, System.EventArgs e)
		{
			midiPlayer.Tempo = Convert.ToInt32(this.textTempo.Text);
		}

		private void buttonBrowse_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog dialog = new OpenFileDialog();

			// dialog.InitialDirectory = ".";
			dialog.Filter = "MIDI (SMF) files (*.mid)|*.mid|All files (*.*)|*.*";
			dialog.FilterIndex = 0;
			dialog.RestoreDirectory = true;

			if(dialog.ShowDialog() == DialogResult.OK)
			{
				this.textFilename.Text = dialog.FileName;
			}
		
		}
	}
}
